unit demofrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  Menus, PasScr;
type
  TForm1 = class(TForm)
    PasScript1: TPasScript;
    PasScript2: TPasScript;
    PasScript3: TPasScript;
    PasScript5: TPasScript;
    PasScript6: TPasScript;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    PasScript7: TPasScript;
    PasScript8: TPasScript;
    Button12: TButton;
    MainMenu1: TMainMenu;
    ABout1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Button13: TButton;
    PasScript9: TPasScript;
    PasScript4: TPasScript;
    Button4: TButton;
    Button14: TButton;
    PasScript10: TPasScript;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure PasScript7BeforeParsing(var Sender: TPasScript);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure ABout1Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  PasScript1.Run;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  PasScript2.Run;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  PasScript3.Run;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  PasScript4.Run;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  PasScript5.Run;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  PasScript6.Run;
end;

procedure TForm1.Button7Click(Sender: TObject);
var
  PasScript : TPasScript;
begin
  PasScript := TPasScript.Create( Self );
  PasScript.ScriptFileName := 'demo1.pas';

  if PasScript.SaveBinProg then
    ShowMessage( 'File demo1.pb was created' );

  PasScript.Free;
end;

procedure TForm1.Button8Click(Sender: TObject);
var
  PasScript : TPasScript;
begin
  PasScript := TPasScript.Create( Self );
  PasScript.ScriptFileName := 'demo1.pb';
  PasScript.LoadBinProg;
  PasScript.Run;
  PasScript.Free;
end;

procedure TForm1.Button9Click(Sender: TObject);
var
  PasScript : TPasScript;
  N : Integer;
begin
  PasScript := TPasScript.Create( Self );
  PasScript.ScriptFileName := 'demo1.pas';
  N := PasScript.CallFunction( 'fact', [3] );
  ShowMessage( IntToStr( N ) );
  PasScript.Free;
end;

procedure TForm1.Button10Click(Sender: TObject);
var
  PasScript : TPasScript;
begin
  PasScript := TPasScript.Create( Self );
  PasScript.ScriptFileName := 'demo1.pas';
  PasScript.CallProcedure( 'Hanoi', [3,'X','Y','Z'] );
  PasScript.Free;
end;

function GreatestDivisor( A, B : Integer ) : Integer; stdcall;
var
  R, R1, R2 : Integer;
  Fin : boolean;
begin
  if ( A = 0 ) or ( B = 0 ) then
    result := Abs( A + B )
  else
  begin
    R2 := A;
    R1 := B;
    repeat
      R := R2 - R1 * ( R2 div R1 );
      if R = 0 then Fin := true
      else
      begin
        R2 := R1;
        R1 := R;
        Fin := false;
      end
    until Fin;
    result := Abs( R1 );
  end;
end;

function Ln( X : Double ) : Double; stdcall;
begin
  Result := System.Ln( X );
end;

function CurrentDate : String; stdcall;
begin
  result := DateToStr( Now );
end;

procedure TForm1.PasScript7BeforeParsing(var Sender: TPasScript);
begin
  Sender.AppDelphiFunction('GreatestDivisor', [typeINT, typeINT],
                            @GreatestDivisor, typeINT);
  Sender.AppDelphiFunction('Ln', [typeREAL],
                            @Ln, typeREAL);
  Sender.AppDelphiFunction('CurrentDate', [],
                            @CurrentDate, typeSTRING);
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
  PasScript7.Run;
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
  PasScript8.Run;
end;

procedure TForm1.ABout1Click(Sender: TObject);
begin
  ShowMessage( 'Component TPasScript demo program' + #13#10 + #13#10 +
               'Copyright (c) 1999-2000 by A.Baranovsky' + #13#10 +
               '           ab@virtlabor.donbass.com' );
end;

procedure TForm1.Button13Click(Sender: TObject);
var
  A : array[ 1..3, 1..2 ] of Integer;
  I, J : Integer;
begin
  for I:=1 to 3 do
    for J:=1 to 2 do
      A[ I, J ] := I + J;

  ShowMessage( 'Delphi data before script using:' + #13#10 +
               'A[1,1]=' + IntToStr( A[1,1] ) + #13#10 +
               'A[1,2]=' + IntToStr( A[1,2] ) + #13#10 +
               'A[2,1]=' + IntToStr( A[2,1] ) + #13#10 +
               'A[2,2]=' + IntToStr( A[2,2] ) + #13#10 +
               'A[3,1]=' + IntToStr( A[3,1] ) + #13#10 +
               'A[3,2]=' + IntToStr( A[3,2] ) );

  PasScript9.Parse;
  PasScript9.SetParameterList( 'P1 777 3.14' );
  PasScript9.Associate( Addr(A), 'A' );
  PasScript9.Run;

  ShowMessage( 'Delphi data after script using:' + #13#10 +
               'A[1,1]=' + IntToStr( A[1,1] ) + #13#10 +
               'A[1,2]=' + IntToStr( A[1,2] ) + #13#10 +
               'A[2,1]=' + IntToStr( A[2,1] ) + #13#10 +
               'A[2,2]=' + IntToStr( A[2,2] ) + #13#10 +
               'A[3,1]=' + IntToStr( A[3,1] ) + #13#10 +
               'A[3,2]=' + IntToStr( A[3,2] ) );

end;

procedure TForm1.Button14Click(Sender: TObject);
begin
  PasScript10.Run;
end;

end.
